define("epi/shell/dgrid/Focusable", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect"
], function(declare, lang, aspect) {

    return declare([], {

        postCreate: function() {
            this.inherited(arguments);

            // Reset the focus node after the grid is updated. This is a bug in dgrid: https://github.com/SitePen/dgrid/issues/899
            this._listeners.push(aspect.after(this, "_restoreFocus", lang.hitch(this, function(row) {
                if (!this._focusedNode) {
                    row = row && this.row(row);
                    this._focusedNode = row && row.element;
                }
            }), true));
        },

        isFocusable: function() {
            // summary:
            //      Indicates whether this grid can currently be focused.
            // tags:
            //      public
            return !!this._focusedNode;
        },

        focus: function(element) {
            // summary:
            //      Set focus to the content of the grid.
            // tags:
            //      public
            if (typeof element == "string") {
                element = this._focusedNode;
            }
            this.inherited(arguments, [element]);
        }
    });
});
